Redmine - Feature #7246

Handle "named branch" for mercurial
2011-01-07 14:34 - Thomas Capricelli

Status: Closed Start date: 2011-01-07
Priority: Normal Due date:

Assignee: Toshi MARUYAMA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 1.2.0

Resolution: Fixed

Description

Mercurial has a concept of branches inside the same repository (as opposed to "use another repository as branch”). Currently,
redmine only 'sees' the main branch and not the other ones.

Handling the named branches would mean:
e see commits from those branches in the repository tab (/projects/xx/repository/, /projects/xx/repository/revisions, individual file

revision logs, ...)
e use commits on those branches when matching for 'fixes' 'refs' and other actions

Related issues:

Related to Redmine - Defect #4924: mercurial reader disregard information fro... Closed 2010-02-24
Related to Redmine - Feature #4455: Mercurial overhaul Closed 2009-12-21
Related to Redmine - Feature #1981: display mercurial tags Closed 2008-10-02
Related to Redmine - Defect #7984: Confusing revisions links on repository root New 2011-03-24
Related to Redmine - Feature #5083: Add the ability to view a range of revisions New 2010-03-15
Related to Redmine - Feature #5386: Branch/Tags in Changeset Description New 2010-04-27
Related to Redmine - Feature #2120: Different views between develop and funci... Closed 2008-10-31
Related to Redmine - Feature #3909: Mercurial: show repository graphic history Closed 2009-09-23
Related to Redmine - Feature #5501: Git: Mercurial: Adding visual merge/branc... Closed 2010-05-11
Related to Redmine - Feature #539: Repository browser per Project Version. New

Related to Redmine - Patch #6159: Subversion: latest changesets performance ... New 2010-08-17
Related to Redmine - Feature #5279: Branch level associations between project... New 2010-04-09
Related to Redmine - Feature #1311: Subversion: Show revision histories for b... New 2008-05-27
Related to Redmine - Patch #3357: Revision log relative to current location i... New 2009-05-13
Related to Redmine - Defect #3943: Subversion: Directory revision list contai... New 2009-09-29
Related to Redmine - Feature #1406: Browse through Git branches Closed 2008-06-09

Associated revisions

Revision 4867 - 2011-02-18 06:00 - Toshi MARUYAMA

scm: mercurial: entries unit lib test for named branch (#7246).

Revision 4871 - 2011-02-18 08:14 - Toshi MARUYAMA

scm: mercurial: temporary disable tags and branches at model (#1981, #7246, #4455).
Until latest_changesets supports tags and branches.

Revision 4874 - 2011-02-18 08:15 - Toshi MARUYAMA

scm: mercurial: support named branches at adapter (#7246).

Contributed by Yuya Nishihara.

Revision 4875 - 2011-02-18 08:15 - Toshi MARUYAMA

scm: mercurial: unit test for named branches at adapter (#7246).
Revision 4989 - 2011-03-02 11:17 - Toshi MARUYAMA
scm: mercurial: wrap revison, tag and branch with URL encoding for entries (#4455, #1981, #7246).

Revision 5101 - 2011-03-13 01:47 - Toshi MARUYAMA

scm: mercurial: add new "rhlog()" function in helper extension (#7246, #4455).
For latest changesets supporting named branch.

Revision 5102 - 2011-03-13 01:48 - Toshi MARUYAMA

scm: mercurial: add new "nodes_in_branch()" method in adapter (#7246, #4455).
For latest changesets supporting named branch.

Revision 5103 - 2011-03-13 11:52 - Toshi MARUYAMA

scm: mercurial: add tests for "nodes_in_branch()" method in adapter (#7246, #4455).

Revision 5108 - 2011-03-13 16:03 - Toshi MARUYAMA

scm: mercurial: remove unused parameters from "nodes_in_branch()" method in adapter (#7246, #4455).

Revision 5112 - 2011-03-14 03:23 - Toshi MARUYAMA

scm: mercurial: wrap revision of cat and annotate with URL encoding (#1981, #7246).

Revision 5113 - 2011-03-14 05:54 - Toshi MARUYAMA

scm: mercurial: prepare test of wrapping revision of cat and annotate with URL encoding (#1981, #7246).

Revision 5115 - 2011-03-14 05:55 - Toshi MARUYAMA

scm: mercurial: add test of non ASCIlI named branch in unit adapter test (#7246).

Revision 5117 - 2011-03-14 09:15 - Toshi MARUYAMA

scm: mercurial: prepare tests of named branch and tag in unit model test (#1981, #7246).

Revision 5118 - 2011-03-14 09:15 - Toshi MARUYAMA

scm: mercurial: prepare tests of named branch and tag in functional test (#1981, #7246).

Revision 5127 - 2011-03-14 14:41 - Toshi MARUYAMA

scm: mercurial: latest changesets support named branch (#7246).

Revision 5128 - 2011-03-14 14:41 - Toshi MARUYAMA

scm: mercurial: add test of latest changesets support named branch in unit model test (#7246).

Revision 5129 - 2011-03-14 14:41 - Toshi MARUYAMA

scm: mercurial: branches and tags are enable in model (#1981, #7246).

Revision 5130 - 2011-03-14 14:42 - Toshi MARUYAMA

scm: mercurial: add named branch test in functional test (#7246).

Revision 5218 - 2011-03-25 00:42 - Toshi MARUYAMA

scm: backout r5213. do not display both 'View all revisions' and 'View revision' links (#7984, #7246).
Git and Mercurial support branch.

Git in repository root shows master branch.
Git master branch does not have all revisions.

Mercurial default branch is default branch.
Mercurial shows tip in repository root.

Mercurial does not treat directory. "hg log DIR" costs high.

Getting correct limited changesets in sub directory and branch is very heavy.
So, if there is no recent revision in sub directory and branch,

no changeset shows.
History

#1 - 2011-03-15 06:14 - Toshi MARUYAMA
- % Done changed from 0 to 70

#2 - 2011-04-30 08:26 - Toshi MARUYAMA
- File hg-root.png added

- File hg-1.1-stable-rev.png added

- File hg-1.1-stable-url-path.png added

- File hg-1.1-stable-file.png added

- Status changed from New to Closed

- Target version set to 1.2.0

- % Done changed from 70 to 0

- Resolution set to Fixed

We finished implementing the feature of Mercurial named branches browsing based on git branches implementation in #1406.

These are images of Redmine hgsubversion mirror.
https://bitbucket.org/redmine/redmine-all

#™ test00 - / - Repository - r.. =

P

o (& @@y |® 192.168.11.90:5001/projects/test00/repository

Home My page Projects Administration Help Logged in as admin My account Sign out n
test00 Sl umptoapopect +

Overview  Activity Issues  Mew issue  Gantt Calendar MNews Documents — Wiki Files

root illly Statistics | Branch: Lv || Tag: v | Rcuisicn:l

Name Size Revision Age Comment

o Japp

@ _J config .Isandboxlrails-2.3

@ 32 db .sandboxlrails-2.2

a [J doc

a _Jextra

a ] files

aJlib

@ Jlog

@ _J public

@ _Jscript

a ] test

o (23 tmp

a _J vendor
Jgitignore 477 Bytes 4822 :4zeddcedc2dd 2 months tmaruyama scm: mercurial: ignore redminehelper.pyc and re..
hgignore 479 Bytes 5223:1¢9d1¢2fe775 about 1 month tmaruyama add .svn/ and .git/ to .hgignore. "hg addremov...
hgtags 470 Bytes 996:95080ef43331  over 3 years  jplang  tagged version 0.6.2

1]
https://www.redmine.org/issues/1406
https://bitbucket.org/redmine/redmine-all

& test00 - / - Repository - r... *

o @ @ [@ 192.168.11.80:5001/projects/test00/repository/show?rev=1.1-stable {Lr] Lyl A
e ——
root @ 1 .1 _stable illy Statistics | Branch: [1.Istable ¥ || Tag: | vl Revision:l
Name Size Revision Age Author Comment
3 app
J config
Jdb
a _J doc
a _Jextra
a _J files
a [Jlib
8 [ Jlog
& ] public
8 | script
@ ] test
@ _Jtmp
a _J vendor
| .gitignore 343 Bytes 4802:4c579058c227 3 manths jbbarth Merged r4813 from trunk.
| .hgignare 336 Bytes 4802:4c570058c227 3 manths jbbarth Merged r4813 from trunk.
| .hgtags 658 Bytes 5582:53ebalbc3ad0 about 20 hours  jplang  tagged version 1.1.3
| README.rdoc 208 Bytes 3834:f61fB857636fe e edavis10 Readme update,
| Rakefile 307 Bytes 63:9265369022aa over 4 years  jplang  trunk moved from /trunk/redmine to /trunk
Latest revisions
# Date Author Comment
5582:53ebalbc3ad0 @ 04/29/2011 06:37 jplang tagged version 1.1.3
pm
5580:72f1d5335zase O @ 04/29/2011 06:23 jplang Updates for 1.1.3 release.
pm
5570:358b6f9628h6 © O 04/29/2011 06:07 jplang Merged r5285 from trunk.
pm k4
& test00 - / - Repository - r... *

Home My page Pro s Administration Help

{ in as admin My account Sign :_:un

o @ @ [O 192.168.11.90:5001/projects/test00/repository/revisions/1.1-stable/show ﬁ] Oog I &
—_———
root @ 1.1-stable ill Statistics | Branch: [T Tstabie v | Tag: | v | Revision: [ |
Name Size Revision Age Author Comment
g ] app
@ ] config
a | Jdb
a _J doc
a _Jextra
a _J files
a ] lib
8 [ Jlog
& ] public
8 | script
@ ] test
@ _Jtmp
a _J vendor
Jgitignare 343 Bytes 4802:4c579058c227 3 manths jbbarth Merged r4813 from trunk.
hgignare 336 Bytes 4802:4c570058c227 3 manths jbbarth Merged r4813 from trunk.
hgtags 658 Bytes 5582:53ebalbc3ad0 asbout 20 hours  jplang  tagged version 1.1.3
README.rdoc 208 Bytes 3834:f61f857636fe 10 months edavis10 Readme update.
Rakefile 307 Bytes 63:9265369022aa over 4 years  jplang  trunk moved from /trunk/redmine to /trunk
Latest revisions
# Date Author Comment
5582:53ebalbc3ad0 @ 04/29/2011 06:37 jplang tagged version 1.1.3
pm
5580:72f1d5335z8:e O @ 04/29/2011 06:23 jplang Updates far 1.1.3 release.
pm
5570:358b6f9628h6 © O 04/29/2011 06:07 jplang Merged r5285 from trunk.
pm =]
&™% test00 - fapp/controllersy...
@0 @ o | @ 192.168.11.90:500lfprojectsfte5t00£rep05it0r}f,’revi5ir:msfl.l—stable,’changes,’appﬁcontrol|erﬂ'] a3 I §

test00 search: |

Overview  Activity Issues  Mew issue Gantt Calendar Mews  Documents  Wiki Files EEREGISIGIEE  Settings

root / app / contro"ers / illy Statistics | Branch: [Listable ¥ || Tag: | ¥ | | Revision:
issues_controller.rb @ 1.1-stable

History | View | Annotate | Download (12.2 kB)

# Date Author Comment
5578:686d11ded50b @& 04/29/2011 06:06 jplang Merged r5283 from trunk.
pm
4758:68c2d01bf4d2 © @ 01/30/2011 03:08 jplang Merged r4741 and r4764 from trunk.
pm
4641:06854970dabe o 01/08/2011 09:24 tmaruyama Merged r4652 from trunk.
am

(4]

There is a discussion about the top page of a repository.
Please see #7984.

use commits on those branches when matching for 'fixes' 'refs' and other actions
https://www.redmine.org/issues/7984

| can not understand your request.

Please create new issue with descriptions in detail.
